/*
 * Copyright (C) 2020-2021 Aloysius Indrayanto
 *
 * This file is part of the eCxx library, see LICENSE file for the license details.
 */


#include <eCxx/eCxx_ColorSpace.h>
#include <eCxx/eCxx_LEDDriver.h>

#include "NodeMCU_Common.h"


//
// Include common source code for WS2812B LED matrix test application
//
#include "../CommonCode/WS2812BMatrix_Common.h"


//
// The init function
//
void eCxx_user_init()
{
    // Initialize application
    initBasicNodeMCUApp();

    // Enable the 74LVC541 buffers on the eCxx NodeMCU development board because
    // the I2S_DATA pin is buffered
    App::setPinMode  ( eCxx::NodeMCU::D0, eCxx::Application::PinMode::Output ); // GPIO16
    App::digitalWrite( eCxx::NodeMCU::D0, false                              ); // The buffers are active low

    // Initialize the driver
    ws2812b.begin( eCxx::NodeMCU::I2S_DATA, cfx.BufferElementCount, cfx.colorBufferData() );

    // Update the WS2812B for the first time (turn off all LEDs)
    ws2812b.update();
}


//
// The task function
//
void eCxx_user_task()
{
    // Process event and update the LED matrix animation
    eCxx_user_task_updateWS2812BLEDMatrixAnimation();
}
